/* config.h -- (C) Geoffrey Reynolds, May 2006.

   Compiler dependant configuration.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
*/

#ifdef _MSC_VER
# ifndef inline
#  define inline __inline
# endif
#endif

#ifdef __GNUC__
# define attribute(list) __attribute__(list)
#else
# define attribute(list)
#endif

/* Define HAVE_GETRUSAGE if sys/resource.h declares getrusage()
 */
#ifndef HAVE_GETRUSAGE
# if defined(_MSC_VER) || defined(__MINGW32__)
#  define HAVE_GETRUSAGE 0
# else
#  define HAVE_GETRUSAGE 1
# endif
#endif

/* Define HAVE_SETPRIORITY if sys/resource.h declares getpriority().
 */
#ifndef HAVE_SETPRIORITY
# if defined(_MSC_VER) || defined(__MINGW32__)
#  define HAVE_SETPRIORITY 0
# else
#  define HAVE_SETPRIORITY 1
# endif
#endif

/* Define HAVE_ALARM if signal.h defines SIGALRM
 */
#ifndef HAVE_ALARM
# if defined(_MSC_VER) || defined(__MINGW32__)
#  define HAVE_ALARM 0
# else
#  define HAVE_ALARM 1
# endif
#endif

/* These definition are missing from mingw32 3.4.5
 */
#if defined(__MINGW32__)
# define ffs __builtin_ffs
# define ffsl __builtin_ffsl
# define ffsll __builtin_ffsll
#endif

/* Define HAVE_FFS if string.h defines ffs, ffsl, ffsll.
 */
#ifndef HAVE_FFS
# if defined(_MSC_VER)
#  define HAVE_FFS 0
# else
#  define HAVE_FFS 1
# endif
#endif

/* Define NEED_UNDERSCORE if global assembler symbols need to be prepended
   by '_'.
*/
#ifndef NEED_UNDERSCORE
# if defined(__MINGW32__) || defined(__APPLE__)
#  define NEED_UNDERSCORE 1
# else
#  define NEED_UNDERSCORE 0
# endif
#endif

/* Define HAVE_MEMALIGN if malloc.h declares a memalign() function.
 */
#ifndef HAVE_MEMALIGN
# if defined(__MINGW32__) || defined(_MSC_VER)
#  define HAVE_MEMALIGN 0
# else
#  define HAVE_MEMALIGN 1
# endif
#endif

/* Define HAVE_MMAP if sys/mman.h declares a mmap() function.
 */
#ifndef HAVE_MMAP
# if defined(__MINGW32__) || defined(_MSC_VER)
#  define HAVE_MMAP 0
# else
#  define HAVE_MMAP 1
# endif
#endif

/* Define HAVE_MALLOPT if malloc.h declares a mallopt() function.
 */
#ifndef HAVE_MALLOPT
# if defined(__unix__)
#  define HAVE_MALLOPT 1
# else
#  define HAVE_MALLOPT 0
# endif
#endif
