/* mulmod-i386.S -- (C) Geoffrey Reynolds, November 2006.

   uint64_t mulmod64(uint64_t a, uint64_t b, uint64_t p);
     %edx:%eax <-- a*b (mod p).
     Assumes %st(0) contains 1.0/p.
     Assumes FPU rounding mode is round-to-zero.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
*/

#include "config.h"

#if NEED_UNDERSCORE
#define mulmod64 _mulmod64
#endif

	.text
	.globl mulmod64
	.p2align 4

mulmod64:
	push	%ebx
	sub	$16, %esp

	fildll	32(%esp)
	fildll  24(%esp)
	mov	32(%esp), %eax
	mov	32(%esp), %ecx
	mov	36(%esp), %ebx
	mull	24(%esp)
	fmulp	%st(0), %st(1)
	imul	24(%esp), %ebx
	fmul	%st(1), %st(0)
	imul	28(%esp), %ecx
	mov	%eax, 8(%esp)
	add	%ebx, %ecx
	fistpll	(%esp)
	add	%ecx, %edx
	mov	%edx, 12(%esp)
	mov	(%esp), %eax
	mov	4(%esp), %edx
	mov	44(%esp), %ebx
	mov	40(%esp), %ecx
	imul	%eax, %ebx
	imul	%edx, %ecx
	mull	40(%esp)
	add	%ebx, %ecx
	mov	12(%esp), %ebx
	add	%ecx, %edx
	mov	8(%esp), %ecx
	sub	%eax, %ecx
	sbb	%edx, %ebx
	mov	%ecx, %eax
	mov	%ebx, %edx
	sub	40(%esp), %ecx
	sbb	44(%esp), %ebx
	jl	0f
	mov	%ecx, %eax
	mov	%ebx, %edx
0:
	add	$16, %esp
	pop	%ebx
	ret
